﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Syncfusion.Data.Extensions;
using Syncfusion.Data;
using Xamarin.Forms;
using System.Collections;

namespace SfDataGrid_Sample
{
    public class ViewModel : INotifyPropertyChanged
    {
        public ViewModel()
        {
            SetRowstoGenerate(30);
            ProductInfoRespository products = new ProductInfoRespository();
            ProductDetails = products.GetProductDetails(100);
        }

        public ViewModel(int count)
        {
            SetRowstoGenerate(count);
            ProductInfoRespository products = new ProductInfoRespository();
            ProductDetails = products.GetProductDetails(count);
        }

        #region ItemsSource

        OrderInfoRepository order;
        private Random random = new Random();
        private ObservableCollection<OrderInfo> ordersInfo;

        private ObservableCollection<ProductInfo> productDetails;

        /// <summary>
        /// Gets or sets the product details.
        /// </summary>
        /// <value>The product details.</value>
        public ObservableCollection<ProductInfo> ProductDetails
        {
            get { return productDetails; }
            set
            {
                productDetails = value;
                RaisePropertyChanged("ProductDetails");
            }
        }

        public ObservableCollection<OrderInfo> OrdersInfo
        {
            get { return ordersInfo; }
            set { this.ordersInfo = value; }
        }

        #endregion

        #region ItemSource Generator

        public void SetRowstoGenerate(int count)
        {
            order = new OrderInfoRepository();
            ordersInfo = order.GetOrderDetails(count);
        }

        internal void ItemsSourceRefresh()
        {
            var count = random.Next(1, 6);

            for (int i = 11000; i < 11000 + count; i++)
            {
                int val = i + random.Next(100, 150);
                this.OrdersInfo.Insert(0, order.RefreshItemsource(val));
            }
        }

        internal void LoadMoreItems()
        {
            for (int i = 0; i < 20; i++)
                this.OrdersInfo.Add(order.GenerateOrder(OrdersInfo.Count + 1));
        }

        #endregion

        
        #region INotifyPropertyChanged implementation

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion
    }
}
